;
; Module Description:
;    Locker - Computer Locking Program Version 1.10
;    Copyright (c) 1997 MATTsoft, All rights reserved.
; Purpose:
;    Zamyka pocitac po stisku <ctrl>+<alt>+<end>, odemkne se zadanim hesla.
;
        TITLE Locker - Computer Locking Program
        NAME LOCKER
        LOCALS @@
        MODEL SMALL
        .286
;
PSP_envirn_seg  equ     2Ch
data_1e		equ	5Dh
data_17e	equ	4A4h

seg_a		segment	byte public
		assume	cs:seg_a, ds:seg_a


		org	100h

locker		proc	far

start:
		pushf				; Push flags
		push	cs
		mov	ax,2B1h
		push	ax
		iret				; Interrupt return
data_2		db	0
data_3		dd	00000h
data_5		db	0C9h
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0CDh, 4Eh,0CDh, 4Eh,0CDh
		db	 4Eh,0CDh, 4Eh,0BBh, 4Eh
		db	'N N N N N N N N N N NN'
		db	'N N NLOoOcOkOeOdO N NN'
		db	'N N N N N N N N N N NN'
		db	0C8h, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0CDh, 4Eh
		db	0CDh, 4Eh,0CDh, 4Eh,0CDh, 4Eh
		db	0BCh
		db	4Eh
data_6		db	'+;*+ 9', 27h, '0', 0
		db	10 dup (24h)
data_8		db	24h
data_9		dw	0

locker		endp

;
;                              SUBROUTINE
;

sub_1		proc	near
		mov	ah,0Fh
		int	10h			; Video display   ah=functn 0Fh
						;  get state, al=mode, bh=page
						;   ah=columns on screen
		cmp	al,7
		je	loc_1			; Jump if equal
		mov	ax,0B800h
		jmp	short loc_2
		db	90h
loc_1:
		mov	ax,0B000h
loc_2:
		mov	es,ax
		mov	bx,data_17e
		mov	si,offset data_5
		mov	cx,0
loc_3:
		mov	ah,cs:[si]
		mov	al,es:[bx]
		mov	cs:[si],al
		mov	es:[bx],ah
		inc	si
		inc	bx
		inc	cl
		cmp	cl,18h
		jne	loc_3			; Jump if not equal
		mov	cl,0
		add	ch,1
		add	bx,88h
		cmp	ch,5
		jne	loc_3			; Jump if not equal
		retn
sub_1		endp


;
;                              SUBROUTINE
;

sub_2		proc	near
loc_4:
		mov	ah,11h
		int	16h			; Keyboard i/o  ah=function 11h
						;  get status, if zf=0  al=char
		pushf				; Push flags
		mov	ah,86h
		mov	cx,0
		mov	dx,100h
		int	15h			; General services, ah=func 86h
						;  wait cx:dx microseconds
		cmp	cs:data_9,0
		je	loc_5			; Jump if equal
		dec	cs:data_9
		cmp	cs:data_9,0
		jne	loc_5			; Jump if not equal
		in	al,61h			; port 61h, 8255 port B, read
		and	al,0FCh
		out	61h,al			; port 61h, 8255 B - spkr, etc
loc_5:
		popf				; Pop flags
		jz	loc_4			; Jump if zero
		retn
sub_2		endp


;
;
;                       External Entry Point
;
;

int_09h_entry	proc	far
		pushf				; Push flags
		push	ax
		mov	ah,2
		int	16h			; Keyboard i/o  ah=function 02h
						;  get shift status in al
		and	al,0Fh
		cmp	al,0Ch
		jne	loc_7			; Jump if not equal
		cmp	cs:data_2,1
		je	loc_6			; Jump if equal
		in	al,60h			; port 60h, keybd scan or sw1
		cmp	al,4Fh			; 'O'
		je	loc_8			; Jump if equal
		jmp	short loc_7
		db	90h
loc_6:
		in	al,60h			; port 60h, keybd scan or sw1
		cmp	al,53h			; 'S'
		jne	loc_7			; Jump if not equal
		mov	al,20h			; ' '
		out	20h,al			; port 20h, 8259-1 int command
						;  al = 20h, end of interrupt
		pop	ax
		popf				; Pop flags
		iret				; Interrupt return
int_09h_entry	endp

loc_7:
		pop	ax
		popf				; Pop flags
		jmp	cs:data_3
loc_8:
		push	es
		push	bx
		push	si
		push	cx
		mov	cs:data_2,1
		mov	al,20h			; ' '
		out	20h,al			; port 20h, 8259-1 int command
						;  al = 20h, end of interrupt
		call	sub_1
		mov	bx,184h
loc_9:
		call	sub_2
		xor	ax,ax			; Zero register
		int	16h			; Keyboard i/o  ah=function 00h
						;  get keybd char in al, ah=scan
		cmp	al,0Dh
		je	loc_11			; Jump if equal
		cmp	al,61h			; 'a'
		jb	loc_10			; Jump if below
		cmp	al,7Ah			; 'z'
		ja	loc_10			; Jump if above
		sub	al,20h			; ' '
loc_10:
		xor	al,0FFh
		xor	al,bl
		cmp	al,cs:[bx]
		jne	loc_12			; Jump if not equal
		inc	bx
		cmp	byte ptr cs:[bx],0
		jne	loc_9			; Jump if not equal
		jmp	short loc_13
		db	90h
loc_11:
		mov	ax,533h
		out	42h,al			; port 42h, 8253 timer 2 spkr
		mov	al,ah
		out	42h,al			; port 42h, 8253 timer 2 spkr
		in	al,61h			; port 61h, 8255 port B, read
		or	al,3
		out	61h,al			; port 61h, 8255 B - spkr, etc
		mov	cs:data_9,2800h
loc_12:
		mov	bx,184h
		jmp	short loc_9
loc_13:
		call	sub_2
		xor	ax,ax			; Zero register
		int	16h			; Keyboard i/o  ah=function 00h
						;  get keybd char in al, ah=scan
		cmp	al,0Dh
		jne	loc_11			; Jump if not equal
		call	sub_1
		mov	cs:data_2,0
		in	al,61h			; port 61h, 8255 port B, read
		and	al,0FCh
		out	61h,al			; port 61h, 8255 B - spkr, etc
						;  al = 0, disable parity
		pop	cx
		pop	si
		pop	bx
		pop	es
		pop	ax
		popf				; Pop flags
		iret				; Interrupt return
			                        ;* No entry point to code
		mov	es,cs:PSP_envirn_seg
		mov	ah,49h
		int	21h			; DOS Services  ah=function 49h
						;  release memory block, es=seg
		mov	bx,data_1e
		mov	ax,[bx]
		cmp	ax,3F2Dh
		je	loc_14			; Jump if equal
		cmp	al,3Fh			; '?'
		je	loc_14			; Jump if equal
		cmp	ax,532Dh
		je	loc_15			; Jump if equal
		cmp	al,53h			; 'S'
		je	loc_15			; Jump if equal
		mov	ax,3509h
		int	21h			; DOS Services  ah=function 35h
						;  get intrpt vector al in es:bx
		mov	word ptr data_3,bx
		mov	word ptr data_3+2,es
		mov	ax,2509h
		mov	dx,offset int_09h_entry
		int	21h			; DOS Services  ah=function 25h
						;  set intrpt vector al to ds:dx
		mov	ax,3100h
		mov	dx,2B1h
		add	dx,0Fh
		shr	dx,1			; Shift w/zeros fill
		shr	dx,1			; Shift w/zeros fill
		shr	dx,1			; Shift w/zeros fill
		shr	dx,1			; Shift w/zeros fill
		int	21h			; DOS Services  ah=function 31h
						;  terminate & stay resident
						;   al=return code,dx=paragraphs
loc_14:
		mov	ah,9
		mov	dx,offset data_10	; ('LOCKER v1.1 ')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		int	20h			; DOS program terminate
loc_15:
		mov	ah,9
		mov	dx,offset data_11	; ('Enter_your_password:')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		mov	bx,184h
loc_16:
		xor	ax,ax			; Zero register
		int	16h			; Keyboard i/o  ah=function 00h
						;  get keybd char in al, ah=scan
		cmp	al,61h			; 'a'
		jb	loc_17			; Jump if below
		cmp	al,7Ah			; 'z'
		ja	loc_17			; Jump if above
		sub	al,20h			; ' '
loc_17:
		xor	al,0FFh
		xor	al,bl
		cmp	al,cs:[bx]
		jne	loc_18			; Jump if not equal
		inc	bx
		cmp	byte ptr cs:[bx],0
		jne	loc_16			; Jump if not equal
		jmp	short loc_19
		db	90h
loc_18:
		mov	bx,184h
		jmp	short loc_16
loc_19:
		xor	ax,ax			; Zero register
		int	16h			; Keyboard i/o  ah=function 00h
						;  get keybd char in al, ah=scan
		cmp	al,0Dh
		jne	loc_18			; Jump if not equal
		mov	ah,9
		mov	dx,offset data_12	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		mov	bx,184h
loc_20:
		xor	ax,ax			; Zero register
		int	16h			; Keyboard i/o  ah=function 00h
						;  get keybd char in al, ah=scan
		cmp	al,61h			; 'a'
		jb	loc_21			; Jump if below
		cmp	al,7Ah			; 'z'
		ja	loc_21			; Jump if above
		sub	al,20h			; ' '
loc_21:
		cmp	al,8
		je	loc_22			; Jump if equal
		cmp	al,0Dh
		je	loc_24			; Jump if equal
		xor	al,0FFh
		xor	al,bl
		cmp	bx,offset data_8
		je	loc_23			; Jump if equal
		mov	cs:[bx],al
		inc	bx
		jmp	short loc_20
loc_22:
		cmp	bx,184h
		je	loc_23			; Jump if equal
		dec	bx
		jmp	short loc_20
loc_23:
		push	bx
		mov	dl,7
		mov	ah,2
		int	21h			; DOS Services  ah=function 02h
						;  display char dl
		pop	bx
		jmp	short loc_20
loc_24:
		mov	byte ptr cs:[bx],0
		mov	ah,9
		mov	dx,offset data_16	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		mov	ax,3D01h
		mov	dx,offset data_14
		int	21h			; DOS Services  ah=function 3Dh
						;  open file, al=mode,name@ds:dx
		jc	loc_25			; Jump if carry Set
		mov	cs:data_15,ax
		mov	bx,ax
		mov	ax,4200h
		mov	dx,84h
		xor	cx,cx			; Zero register
		int	21h			; DOS Services  ah=function 42h
						;  move file ptr, bx=file handle
						;   al=method, cx,dx=offset
		jc	loc_25			; Jump if carry Set
		mov	ah,40h			; '@'
		mov	bx,cs:data_15
		mov	cx,14h
		mov	dx,offset data_6	; ('+;*+ 9'0')
		int	21h			; DOS Services  ah=function 40h
						;  write file  bx=file handle
						;   cx=bytes from ds:dx buffer
		jc	loc_25			; Jump if carry Set
		mov	ah,3Eh			; '>'
		mov	bx,cs:data_15
		int	21h			; DOS Services  ah=function 3Eh
						;  close file, bx=file handle
		jc	loc_25			; Jump if carry Set
		jmp	short loc_26
		db	90h
loc_25:
		mov	ah,9
		mov	dx,offset data_13	; ('ERROR: Disk error or fil')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
loc_26:
		int	20h			; DOS program terminate
data_10		db	'LOCKER v1.1 (c) 1995 MATTsoft [GNU]',13,10
		db      'http://www.tdp.cz/martin/ martin@tdp.cz'
		db	0Dh, 0Ah, 0Dh, 0Ah, 'Syntax:  LOC'
		db	'KER.COM [/S] [/?]', 0Dh, 0Ah, 0Dh
		db	0Ah, '  /S or -S   Set new passwo'
		db	'rd', 0Dh, 0Ah, '  /? or -?   Thi'
		db	's help', 0Dh, 0Ah, '$'
data_11		db	'Enter_your_password:$'
data_12		db	0Dh, 0Ah, 'Enter_your_new_passwor'
		db	'd:$'
data_13		db	'ERROR: Disk error or file LOCKER'
		db	'.COM no found in current directo'
		db	'ry!', 0Dh, 0Ah, '$'
data_14		db	'LOCKER.COM', 0
data_15		dw	0
data_16		db	0Dh, 0Ah, '$'

seg_a		ends



		end	start
